<template>
	<zj-tab-page ref="tabPage" :defaultActives="[{ key: 'list', label: $route.meta.title+'-列表', essential: true }]">
		<template slot-scope="{activeKey, data}">
			<template-page v-if="activeKey == 'list'" ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
			  :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
			  :operation="operation()" :exportList="exportList">
			</template-page>
			<div v-if="~['add', 'edit', 'detail'].indexOf(activeKey)">
				<zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
				  <zj-form-module title="" label-width="120px" :showPackUp="false"
				    :form-data="formData" :form-items="formItems">
				  </zj-form-module>
				</zj-form-container>
				<div slot="footer" class="dialog-footer">
				  <el-button size="mini" @click="data.removeTab()">取 消</el-button>
				  <el-button v-if="formDialogType !== 2" size="mini" @click="formConfirm(data.removeTab)" type="primary">确 定</el-button>
				</div>
			</div>
		</template>
	</zj-tab-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { chargingStandardTypeList2, getTypeList, getTypeDetail, saveType, deleteType } from "@/api/miniapp";
import ImageUpload from '@/components/file-upload'
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage, ImageUpload },
  mixins: [import_mixin,operation_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "查看"],
      formDialog: false,
      formData: {
        name: "",
        status: true,
		sortNum: 0
      },
		formType: 'add',
		formVisible: false,
    }
  },
  computed: {
	// 事件组合
	optionsEvensGroup() {
		return [
			[
				[
					this.optionsEvensAuth("add", {
						click: () => {
							this.openForm('add')
						}
					})
				],
			]
		]
	},
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 6,
        isShow: true,
        name: 'el-input',
        options: this.businessTypeList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '名称',
          prop: 'name',
          rules: [...required]
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-radio',
        options: [{ label: "开启", value: true }, { label: "禁用", value: false }],
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2 },
        formItemAttributes: {
          label: '状态',
          prop: 'status',
          rules: [...required]
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '排序',
          prop: 'sortNum',
          rules: [...required]
        }
      }
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: chargingStandardTypeList2,
    // 列表导出函数
    exportList() { },
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
	// 表格操作列
	operation() {
		return this.operationBtn({
			detail: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('detail',row.id)
				}
			},
			edit: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('edit',row.id)
				}
			},
			del: {
				btnType: 'text',
				prompt: '确定删除吗？',
				click: ({ row, index, column }) => {
					deleteType({ id: row.id }).then(res => {
					  this.$message({
					    type: 'success',
					    message: `删除成功!`,
					  })
					  this.$refs.pageRef.refreshList()
					})
				}
			}
		})
	},
    // 取消 新增编辑
    formCancel() {
      this.formVisible = false
      this.$refs?.formRef?.resetFields()
      this.$data.formData = this.$options.data().formData
    },
    // 打开 新增编辑 网点表单
    openForm(type, id) {
      this.$refs.tabPage.addTab({
        // 对应显示的模块
        activeKey: type,
        // 唯一标识
        key: type,
        // 页签名称
        label: ({ edit: "编辑", add: "新增", detail: "查看" })[type],
        // 打开时事件
        triggerEvent: () => {
    		this.formCancel()
    		this.$nextTick(()=>{
    			this.formType = type
    			this.formVisible = true
    			if (type == 'add') {
    				this.formDialogType = 0
    			} else if(type == 'edit'){
    				this.formDialogType = 1
    				getTypeDetail({ id }).then(res => {
    					Object.assign(this.formData, res.data)
    				})
    			}else{
    				this.formDialogType = 2
    				getTypeDetail({ id }).then(res => {
    					Object.assign(this.formData, res.data)
    				})
    			}
    		})
        },
        // 关闭时事件
        closeEvent: () => {
          
        }
      })
    },
    formConfirm(cancel) {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          saveType(this.formData).then(res => {
            this.$message({
              type: 'success',
              message: this.formDialogTitles[this.formDialogType] + `成功!`,
            })
            cancel('list')
            this.$refs.pageRef.refreshList()
          })
        }
      })
    },
  }
}
</script>

<style lang="scss" scoped></style>
